<?php

namespace App\Models\Customer;

use App\Entities\Customer\AccountEntity;

class AccountModel extends CustomerModel
{
    const TABLE = "accountinfo";
    const PK = "uid";
    const TITLE = "title";
    protected $table            = self::TABLE;
    protected $primaryKey       = self::PK;
    protected $returnType       = AccountEntity::class;
    protected $allowedFields = [
        "user_uid",
        "clientinfo_uid",
        "bank",
        "title",
        "alias",
        "issue_at",
        "amount",
        "status",
        "updated_at"
    ];
    public function __construct()
    {
        parent::__construct();
    }
    public function getFormFieldRule(string $action, string $field): string
    {
        if (is_array($field)) {
            throw new \Exception(__FUNCTION__ . "=> field가 array 입니다.\n" . var_export($field, true));
        }
        switch ($field) {
            case "user_uid":
            case "clientinfo_uid":
            case "amount":
                $rule  = "required|numeric";
                break;
            case "bank":
            case "title":
            case "alias":
            case "status":
                $rule = "required|trim|string";
                break;
            case "issue_at":
                $rule = "required|valid_date";
                break;
            default:
                $rule = parent::getFormFieldRule($action, $field);
                break;
        }
        return $rule;
    }
}
